## vcmi 0.99+dfsg

=== CMakeLists.txt ===
project(vcmi)
cmake_minimum_required(VERSION 2.8.12)
# TODO:
# 1) Detection of Qt5 and compilation of launcher, unless explicitly disabled

# where to look for cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_HOME_DIRECTORY}/cmake_modules)

# enable Release mode but only if it was not set
if (NOT CMAKE_BUILD_TYPE)
		set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

# VCMI version
set(VCMI_VERSION_MAJOR 0)
set(VCMI_VERSION_MINOR 99)
set(VCMI_VERSION_PATCH 0)

option(ENABLE_ERM "Enable compilation of ERM scripting module" OFF)
option(ENABLE_EDITOR "Enable compilation of map editor" OFF)
option(ENABLE_LAUNCHER "Enable compilation of launcher" ON)
option(ENABLE_TEST "Enable compilation of unit tests" ON)
option(ENABLE_PCH "Enable compilation using precompiled headers" ON)

############################################
#        Documentation section             #
############################################

include(UseDoxygen OPTIONAL)

############################################
#        Building section                  #
############################################

if (APPLE)
	# Default location for thirdparty libs
	set(CMAKE_INCLUDE_PATH "../include" "${CMAKE_OSX_SYSROOT}/usr/include")
	set(CMAKE_LIBRARY_PATH "../lib")
	set(CMAKE_FRAMEWORK_PATH "../Frameworks")
	set(BOOST_ROOT "../")

	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_HOME_DIRECTORY}/bin")
	set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_HOME_DIRECTORY}/bin")
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_HOME_DIRECTORY}/bin")

	set(CMAKE_XCODE_ATTRIBUTE_CONFIGURATION_BUILD_DIR "${CMAKE_HOME_DIRECTORY}/bin/$(CONFIGURATION)")
	set(CMAKE_XCODE_ATTRIBUTE_LD_RUNPATH_SEARCH_PATHS "@executable_path/../Frameworks @executable_path/")

	# Build with clang ang libc++
	set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++11")
	set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")

	# On OS X we use Sparkle framework for updates
	find_path(SPARKLE_INCLUDE_DIR Sparkle.h)
	find_library(SPARKLE_FRAMEWORK NAMES Sparkle)

	# Xcode 5.0 fix
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftemplate-depth=256")

	# Link with iconv
	set(SYSTEM_LIBS ${SYSTEM_LIBS} libiconv.dylib)
endif()

if (WIN32)
	add_definitions(-DBOOST_THREAD_USE_LIB)
	add_definitions(-D_WIN32_WINNT=0x0501)
	set(SYSTEM_LIBS ${SYSTEM_LIBS} ole32 oleaut32 ws2_32 mswsock dbghelp)

	#delete lib prefix for dlls (libvcmi -> vcmi)
	set(CMAKE_SHARED_LIBRARY_PREFIX "") 

	if(MINGW)
		#MinGW: check for iconv (may be needed for boost.locale)
		include(CheckLibraryExists)
		check_library_exists(iconv libiconv_open "" ICONV_FOUND)
		if(ICONV_FOUND)
			set(SYSTEM_LIBS ${SYSTEM_LIBS} iconv)
		endif()

		#MinGW: copy runtime to VCMI location
		get_filename_component(MINGW_BIN_PATH ${CMAKE_CXX_COMPILER} PATH )
		set(dep_files ${dep_files} "${MINGW_BIN_PATH}/libwinpthread-*.dll") 
		set(dep_files ${dep_files} "${MINGW_BIN_PATH}/libgcc_s_*.dll") 
		set(dep_files ${dep_files} "${MINGW_BIN_PATH}/libstdc++-*.dll")

		#MinGW: use O1 to prevent compiler crash in some cases
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O1")
	endif()

	if(MSVC)
		#MSVC: Fix problems with linking
		add_definitions(-DBOOST_ALL_NO_LIB)
		set(Boost_USE_STATIC_LIBS ON)

		#MSVC: Don't link with SDLMain
		set(SDL2_BUILDING_LIBRARY ON)

		#MSVC: Suppress warnings
		add_definitions(-D_CRT_SECURE_NO_WARNINGS)
		add_definitions(-D_SCL_SECURE_NO_WARNINGS)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /wd4251")
	endif()
endif()

if(NOT WIN32)
	INCLUDE(CheckLibraryExists)

	#check if some platform-specific libraries are needed for linking
	CHECK_LIBRARY_EXISTS(rt shm_open "" HAVE_RT_LIB)
	if(HAVE_RT_LIB)
		set(SYSTEM_LIBS ${SYSTEM_LIBS} rt)
	endif()
endif()

set(SYSTEM_LIBS ${SYSTEM_LIBS} ${CMAKE_DL_LIBS})

set(FFmpeg_FIND_COMPONENTS AVFORMAT SWSCALE)
find_package(Boost 1.48.0 COMPONENTS date_time filesystem locale program_options system thread REQUIRED)
find_package(ZLIB REQUIRED)
find_package(FFmpeg REQUIRED)
find_package(Minizip)
if (MINIZIP_FOUND)
    add_definitions(-DUSE_SYSTEM_MINIZIP)
endif()

find_package(SDL2 REQUIRED)
find_package(SDL2_image REQUIRED)
find_package(SDL2_mixer REQUIRED)
find_package(SDL2_ttf REQUIRED)

set(SDL_INCLUDE_DIR "${SDL2_INCLUDE_DIR}")
set(SDLTTF_INCLUDE_DIR "${SDL2_TTF_INCLUDE_DIR}")
set(SDLIMAGE_INCLUDE_DIR "${SDL2_IMAGE_INCLUDE_DIR}")
set(SDLMIXER_INCLUDE_DIR "${SDL2_MIXER_INCLUDE_DIR}")
set(SDL_LIBRARY "${SDL2_LIBRARY}")
set(SDLTTF_LIBRARY "${SDL2_TTF_LIBRARY}")
set(SDLIMAGE_LIBRARY "${SDL2_IMAGE_LIBRARY}")
set(SDLMIXER_LIBRARY "${SDL2_MIXER_LIBRARY}")

include(cotire)

if (ENABLE_EDITOR OR ENABLE_LAUNCHER)
	# Widgets finds its own dependencies (QtGui and QtCore).
	find_package(Qt5Widgets REQUIRED)
endif()

if (ENABLE_LAUNCHER)
	find_package(Qt5Network REQUIRED)
endif()

if(ENABLE_TEST)
	# find_package overwrites BOOST_* variables which are already set, so all components have to be included again
	find_package(Boost 1.48.0 COMPONENTS date_time program_options filesystem system thread locale unit_test_framework REQUIRED)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR NOT WIN32) #so far all *nix compilers support such parameters
	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
		set(CLANG_SPECIFIC_FLAGS "-Wno-mismatched-tags -Wno-unknown-warning-option")
	endif()

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -Wall -Wextra -Wpointer-arith -Wno-strict-aliasing -Wno-switch -Wno-sign-compare -Wno-unused-local-typedefs  -Wno-unused-parameter -Wuninitialized -Wno-overloaded-virtual -Wno-type-limits -Wno-unknown-pragmas -Wno-reorder ${CLANG_SPECIFIC_FLAGS}")

	if(UNIX)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
	endif()

endif()

if(WIN32) # on Win everything goes into H3 root directory
	set(BIN_DIR "." CACHE STRING "Where to install binaries")
	set(LIB_DIR "." CACHE STRING "Where to install main library")
	set(DATA_DIR "." CACHE STRING "Where to install data files")
elseif(APPLE)
	# includes lib path which determines where to install shared libraries (either /lib or /lib64)
	include(GNUInstallDirs)

	set(BIN_DIR "." CACHE STRING "Where to install binaries")
	set(LIB_DIR "." CACHE STRING "Where to install main library")
	set(DATA_DIR "../h3" CACHE STRING "Where to install data files")
else()
	# includes lib path which determines where to install shared libraries (either /lib or /lib64)
	include(GNUInstallDirs)

	if (NOT BIN_DIR)
		set(BIN_DIR "bin" CACHE STRING "Where to install binaries")
	endif()
	if (NOT LIB_DIR)
		set(LIB_DIR "${CMAKE_INSTALL_LIBDIR}/vcmi" CACHE STRING "Where to install main library")
	endif()
	if (NOT DATA_DIR)
		set(DATA_DIR "share/vcmi" CACHE STRING "Where to install data files")
	endif()
endif()

set (AI_LIB_DIR "${LIB_DIR}/AI")
set (SCRIPTING_LIB_DIR "${LIB_DIR}/scripting")

#define required constants
add_definitions(-DM_DATA_DIR="${CMAKE_INSTALL_PREFIX}/${DATA_DIR}")
add_definitions(-DM_BIN_DIR="${CMAKE_INSTALL_PREFIX}/${BIN_DIR}")
add_definitions(-DM_LIB_DIR="${CMAKE_INSTALL_PREFIX}/${LIB_DIR}")

SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/vcmi")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# precompiled header configuration
SET(PCH_PROPERTIES
	COTIRE_ENABLE_PRECOMPILED_HEADER ${ENABLE_PCH}
	COTIRE_ADD_UNITY_BUILD FALSE 
	COTIRE_CXX_PREFIX_HEADER_INIT "StdInc.h"
)

if (ENABLE_ERM)
		add_subdirectory(scripting/erm)
endif()
if (NOT MINIZIP_FOUND)
	add_subdirectory(lib/minizip)
	set(MINIZIP_LIBRARIES minizip)
endif()
add_subdirectory(lib)
add_subdirectory(client)
add_subdirectory(server)
add_subdirectory(AI)
if (ENABLE_EDITOR)
	add_subdirectory(editor)
endif()
if (ENABLE_LAUNCHER)
	add_subdirectory(launcher)
endif()
if(ENABLE_TEST)
	add_subdirectory(test)
endif()

#######################################
#    Installation section             #
#######################################

# For apple these files will be already inside vcmiclient bundle
if (NOT APPLE)
	# copy whole directory but .svn control files
	install(DIRECTORY config DESTINATION ${DATA_DIR} PATTERN ".svn" EXCLUDE)
	# copy vcmi mod along with all its content
	install(DIRECTORY Mods/vcmi DESTINATION ${DATA_DIR}/Mods PATTERN ".svn" EXCLUDE)

	install(FILES vcmibuilder DESTINATION ${BIN_DIR} PERMISSIONS
		OWNER_WRITE OWNER_READ OWNER_EXECUTE
		            GROUP_READ GROUP_EXECUTE
		            WORLD_READ WORLD_EXECUTE)
endif()

if(WIN32)
	file(GLOB dep_files 
		${dep_files} 
		"${CMAKE_FIND_ROOT_PATH}/bin/*.dll")

	#Copy debug versions of libraries if build type is debug. Doesn't work in MSVC!
	if(CMAKE_BUILD_TYPE MATCHES DEBUG)
		set(debug_postfix d)
	endif(CMAKE_BUILD_TYPE MATCHES DEBUG)
	
	if (ENABLE_EDITOR OR ENABLE_LAUNCHER)
		get_target_property(QtCore_location Qt5::Core LOCATION)
		get_filename_component(Qtbin_folder ${QtCore_location} PATH)
		file(GLOB dep_files 
			${dep_files}
			${Qtbin_folder}/Qt5Core${debug_postfix}.dll
			${Qtbin_folder}/Qt5Gui${debug_postfix}.dll
			${Qtbin_folder}/Qt5Widgets${debug_postfix}.dll
			${Qtbin_folder}/icu*.dll)
		file(GLOB dep_qwindows
			${Qtbin_folder}/../plugins/platforms/qwindows${debug_postfix}.dll)
		if(MSVC)
			file(GLOB dep_files 
				${dep_files}
				${Qtbin_folder}/libEGL.dll
				${Qtbin_folder}/libGLESv2.dll)
		endif()
	endif()

	if (ENABLE_LAUNCHER)
		file(GLOB dep_files 
			${dep_files} 
			${Qtbin_folder}/Qt5Network${debug_postfix}.dll)
	endif()

	if(MSVC)
		#install MSVC runtime
		include(InstallRequiredSystemLibraries)
		install(FILES ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS} DESTINATION ${BIN_DIR})
	endif()
	install(FILES ${dep_files} DESTINATION ${BIN_DIR})
	install(FILES ${dep_qwindows} DESTINATION ${BIN_DIR}/platforms)
elseif(NOT APPLE)
	#install icons and desktop file on Linux
	#FIXME: move to client makefile?
	install(FILES "${CMAKE_SOURCE_DIR}/client/icons/vcmiclient.64x64.png"   DESTINATION share/icons/hicolor/64x64/apps RENAME vcmiclient.png)
	install(FILES "${CMAKE_SOURCE_DIR}/client/icons/vcmiclient.48x48.png"   DESTINATION share/icons/hicolor/48x48/apps RENAME vcmiclient.png)
	install(FILES "${CMAKE_SOURCE_DIR}/client/icons/vcmiclient.32x32.png"   DESTINATION share/icons/hicolor/32x32/apps RENAME vcmiclient.png)
	install(FILES "${CMAKE_SOURCE_DIR}/client/icons/vcmiclient.256x256.png" DESTINATION share/icons/hicolor/256x256/apps RENAME vcmiclient.png)
	install(FILES "${CMAKE_SOURCE_DIR}/client/icons/vcmiclient.desktop"     DESTINATION share/applications)
	if (ENABLE_LAUNCHER) #FIXME: move to launcher makefile?
		install(FILES "${CMAKE_SOURCE_DIR}/launcher/vcmilauncher.desktop"     DESTINATION share/applications)
	endif()
endif()

#######################################
#       Packaging section             #
#######################################

set(CPACK_PACKAGE_VERSION_MAJOR ${VCMI_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VCMI_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VCMI_VERSION_PATCH})

# vcmi does not have "patch version" in version string
set(CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}")
#TODO: remove version from Global.h and use this one as define?

set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY 0)

if(WIN32)
	set(CPACK_MONOLITHIC_INSTALL 1)
	set(CPACK_PACKAGE_NAME "VCMI")
	set(CPACK_PACKAGE_VENDOR "VCMI team")
	set(CPACK_PACKAGE_FILE_NAME "vcmi-${CPACK_PACKAGE_VERSION}-win32")
	set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/license.txt")
	set(CPACK_PACKAGE_EXECUTABLES "VCMI_launcher;VCMI")
	set(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_NAME}")
	set(CPACK_NSIS_PACKAGE_NAME "VCMI ${CPACK_PACKAGE_VERSION}")
	set(CPACK_NSIS_INSTALL_ROOT "$PROGRAMFILES")
	set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS " CreateShortCut \\\"$DESKTOP\\\\VCMI.lnk\\\" \\\"$INSTDIR\\\\VCMI_launcher.exe\\\"")
    set(CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS " Delete \\\"$DESKTOP\\\\VCMI.lnk\\\" ")
	
	configure_file("${CMAKE_SOURCE_DIR}/cmake_modules/CMakeCPackOptions.cmake.in" "${CMAKE_BINARY_DIR}/CMakeCPackOptions.cmake" @ONLY)
	set(CPACK_PROJECT_CONFIG_FILE "${CMAKE_BINARY_DIR}/CMakeCPackOptions.cmake")
elseif(APPLE)
	set(CPACK_GENERATOR DragNDrop)

=== AI/CMakeLists.txt ===
project(AI)
cmake_minimum_required(VERSION 2.8)

option(FORCE_BUNDLED_FL "Force to use FuzzyLite included into VCMI's source tree" OFF)

if (NOT FORCE_BUNDLED_FL)
	find_package(Fuzzylite)
else()
	set(FL_FOUND FALSE)
endif()

if (NOT MSVC)
    add_definitions(-DFL_CPP11)
    set(FL_CPP11 ON CACHE BOOL "")
endif()

if (NOT FL_FOUND)
    set(FL_BUILD_BINARY OFF CACHE BOOL "")
    set(FL_BUILD_SHARED OFF CACHE BOOL "")
    add_subdirectory(FuzzyLite/fuzzylite)
endif()
add_subdirectory(BattleAI)
add_subdirectory(StupidAI)
add_subdirectory(EmptyAI)
add_subdirectory(VCAI)

=== client/CMakeLists.txt ===
project(vcmiclient)
cmake_minimum_required(VERSION 2.6)

include_directories(${CMAKE_HOME_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/include ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_HOME_DIRECTORY}/lib)
include_directories(${SDL_INCLUDE_DIR} ${SDLIMAGE_INCLUDE_DIR} ${SDLMIXER_INCLUDE_DIR} ${SDLTTF_INCLUDE_DIR})
include_directories(${Boost_INCLUDE_DIRS} ${ZLIB_INCLUDE_DIR} ${FFMPEG_INCLUDE_DIRS})

set(client_SRCS
		StdInc.cpp
		../CCallback.cpp

		battle/CBattleInterface.cpp
		battle/CBattleAnimations.cpp
		battle/CBattleInterfaceClasses.cpp
		battle/CCreatureAnimation.cpp

		gui/CAnimation.cpp
		gui/CCursorHandler.cpp
		gui/CGuiHandler.cpp
		gui/CIntObject.cpp
		gui/Fonts.cpp
		gui/Geometries.cpp
		gui/SDL_Extensions.cpp

		widgets/AdventureMapClasses.cpp
		widgets/Buttons.cpp
		widgets/CArtifactHolder.cpp
		widgets/CComponent.cpp
		widgets/CGarrisonInt.cpp
		widgets/Images.cpp
		widgets/MiscWidgets.cpp
		widgets/ObjectLists.cpp
		widgets/TextControls.cpp

		windows/CAdvmapInterface.cpp
		windows/CCastleInterface.cpp
		windows/CCreatureWindow.cpp
		windows/CHeroWindow.cpp
		windows/CKingdomInterface.cpp
		windows/CQuestLog.cpp
		windows/CSpellWindow.cpp
		windows/CTradeWindow.cpp
		windows/CWindowObject
		windows/InfoWindows.cpp
		windows/GUIClasses.cpp

		CBitmapHandler.cpp
		CDefHandler.cpp
		CGameInfo.cpp
		Client.cpp
		CMessage.cpp
		CMT.cpp
		CMusicHandler.cpp
		CPlayerInterface.cpp
		CPreGame.cpp
		CVideoHandler.cpp
		Graphics.cpp
		mapHandler.cpp
		NetPacksClient.cpp
		SDLRWwrapper.cpp
)

set(client_HEADERS
		gui/SDL_Pixels.h
		gui/SDL_Compat.h
)

if(APPLE)
	# OS X specific includes
	include_directories(${SPARKLE_INCLUDE_DIR})

	# OS X specific source files
	set(client_SRCS ${client_SRCS} SDLMain.m OSX.mm Info.plist vcmi.icns ../osx/vcmi_dsa_public.pem)
	add_executable(vcmiclient MACOSX_BUNDLE ${client_SRCS} ${client_HEADERS})

	# OS X specific libraries
	target_link_libraries(vcmiclient ${SPARKLE_FRAMEWORK})

	# Because server and AI libs would be copies to bundle they need to be built before client
	add_dependencies(vcmiclient vcmiserver VCAI EmptyAI StupidAI BattleAI minizip)

	# Custom Info.plist
	set_target_properties(vcmiclient PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist)

	# Copy icon file and public key for Sparkle
	set_source_files_properties(vcmi.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	set_source_files_properties(../osx/vcmi_dsa_public.pem PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

	set_target_properties(vcmiclient PROPERTIES XCODE_ATTRIBUTE_LD_RUNPATH_SEARCH_PATHS "@executable_path/../Frameworks @executable_path/")

	# Copy server executable, libs and game data to bundle
	set(BUNDLE_PATH ${CMAKE_HOME_DIRECTORY}/bin/$(CONFIGURATION)/vcmiclient.app/Contents)
	set(MakeVCMIBundle
		# Copy all needed binaries
		mkdir -p ${BUNDLE_PATH}/MacOS/AI &&
		cp ${CMAKE_HOME_DIRECTORY}/bin/$(CONFIGURATION)/vcmiserver ${BUNDLE_PATH}/MacOS/vcmiserver &&
		cp ${CMAKE_HOME_DIRECTORY}/bin/$(CONFIGURATION)/libvcmi.dylib ${BUNDLE_PATH}/MacOS/libvcmi.dylib &&
		cp ${CMAKE_HOME_DIRECTORY}/bin/$(CONFIGURATION)/libminizip.dylib ${BUNDLE_PATH}/MacOS/libminizip.dylib &&
		cp ${CMAKE_HOME_DIRECTORY}/bin/$(CONFIGURATION)/libVCAI.dylib ${BUNDLE_PATH}/MacOS/AI/libVCAI.dylib &&
		cp ${CMAKE_HOME_DIRECTORY}/bin/$(CONFIGURATION)/libStupidAI.dylib ${BUNDLE_PATH}/MacOS/AI/libStupidAI.dylib &&
		cp ${CMAKE_HOME_DIRECTORY}/bin/$(CONFIGURATION)/libEmptyAI.dylib ${BUNDLE_PATH}/MacOS/AI/libEmptyAI.dylib &&
		cp ${CMAKE_HOME_DIRECTORY}/bin/$(CONFIGURATION)/libBattleAI.dylib ${BUNDLE_PATH}/MacOS/AI/libBattleAI.dylib &&
		cp -r ${CMAKE_HOME_DIRECTORY}/osx/vcmibuilder.app ${BUNDLE_PATH}/MacOS/vcmibuilder.app &&

		# Copy frameworks
		sh -c 'cp -r ${CMAKE_HOME_DIRECTORY}/${CMAKE_FRAMEWORK_PATH} ${BUNDLE_PATH}/Frameworks/ || true' &&

		# Copy vcmi data
		mkdir -p ${BUNDLE_PATH}/Data &&
		mkdir -p ${BUNDLE_PATH}/Data/Mods &&
		mkdir -p ${BUNDLE_PATH}/Data/launcher &&
		cp -r ${CMAKE_HOME_DIRECTORY}/config/ ${BUNDLE_PATH}/Data/config/ &&
		cp -r ${CMAKE_HOME_DIRECTORY}/Mods/vcmi/ ${BUNDLE_PATH}/Data/Mods/vcmi/ &&
		sh -c 'cp -r ${CMAKE_HOME_DIRECTORY}/Mods/WoG/ ${BUNDLE_PATH}/Data/Mods/WoG/ || echo "Download WoG mod from http://wiki.vcmi.eu/index.php?title=Mod_list" ' &&
		sh -c 'cp -r ${CMAKE_HOME_DIRECTORY}/Mods/hota/ ${BUNDLE_PATH}/Data/Mods/hota/ || echo "Download HOTA mod from http://wiki.vcmi.eu/index.php?title=Mod_list" ' &&
		cp -r ${CMAKE_HOME_DIRECTORY}/launcher/icons/ ${BUNDLE_PATH}/Data/launcher/icons/)

	add_custom_command(TARGET vcmiclient POST_BUILD COMMAND ${MakeVCMIBundle})
elseif(WIN32)
	add_executable(vcmiclient ${client_SRCS} VCMI_client.rc)
else()
	add_executable(vcmiclient ${client_SRCS})
endif()

if(WIN32)
	set_target_properties(vcmiclient PROPERTIES OUTPUT_NAME VCMI_client)
endif()

target_link_libraries(vcmiclient vcmi ${Boost_LIBRARIES} ${SDL_LIBRARY} ${SDLIMAGE_LIBRARY} ${SDLMIXER_LIBRARY} ${SDLTTF_LIBRARY} ${ZLIB_LIBRARIES} ${FFMPEG_LIBRARIES} ${SYSTEM_LIBS})

set_target_properties(vcmiclient PROPERTIES ${PCH_PROPERTIES})
cotire(vcmiclient)


install(TARGETS vcmiclient DESTINATION ${BIN_DIR})

=== editor/CMakeLists.txt ===
project(vcmieditor)
cmake_minimum_required(VERSION 2.8.7)

include_directories(${CMAKE_HOME_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/include ${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${Qt5Widgets_INCLUDE_DIRS})


set(maped_SRCS
	StdInc.cpp
	Editor.cpp
	Main.cpp
)

set(maped_MOC_HEADERS
	Editor.h
)

set(maped_FORMS
	editor.ui
)

# Tell CMake to run moc when necessary:
set(CMAKE_AUTOMOC ON)

# As moc files are generated in the binary dir, tell CMake
# to always look for includes there:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# We need add -DQT_WIDGETS_LIB when using QtWidgets in Qt 5.
add_definitions(${Qt5Widgets_DEFINITIONS})

# Executables fail to build with Qt 5 in the default configuration
# without -fPIE. We add that here.
set(CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ${CMAKE_CXX_FLAGS}")

qt5_wrap_ui(maped_FORMS_OUT ${maped_FORMS})

add_executable(vcmieditor ${maped_SRCS} ${maped_FORMS_OUT})

# The Qt5Widgets_LIBRARIES variable also includes QtGui and QtCore
target_link_libraries(vcmieditor vcmi ${Qt5Widgets_LIBRARIES})

set_target_properties(vcmieditor PROPERTIES ${PCH_PROPERTIES})
cotire(vcmieditor)

if (NOT APPLE) # Already inside bundle
    install(TARGETS vcmieditor DESTINATION ${BIN_DIR})
endif()

=== launcher/CMakeLists.txt ===
project(vcmilauncher)
cmake_minimum_required(VERSION 2.8.7)

include_directories(${CMAKE_HOME_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/include ${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${ZLIB_INCLUDE_DIR} ${Boost_INCLUDE_DIRS} ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS})
include_directories(${SDL_INCLUDE_DIR})

set(launcher_modmanager_SRCS
    modManager/cdownloadmanager_moc.cpp
    modManager/cmodlist.cpp
    modManager/cmodlistmodel_moc.cpp
    modManager/cmodlistview_moc.cpp
    modManager/cmodmanager.cpp
    modManager/imageviewer_moc.cpp
)

set(launcher_settingsview_SRCS
    settingsView/csettingsview_moc.cpp
)

set(launcher_SRCS
    StdInc.cpp
    ${launcher_modmanager_SRCS}
    ${launcher_settingsview_SRCS}
    main.cpp
    mainwindow_moc.cpp
    launcherdirs.cpp
    jsonutils.cpp
    sdldisplayquery.cpp
)

set(launcher_FORMS
    modManager/cmodlistview_moc.ui
    modManager/imageviewer_moc.ui
    settingsView/csettingsview_moc.ui
    mainwindow_moc.ui
)

# Tell CMake to run moc when necessary:
set(CMAKE_AUTOMOC ON)

# As moc files are generated in the binary dir, tell CMake
# to always look for includes there:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# We need add -DQT_WIDGETS_LIB when using QtWidgets in Qt 5.
add_definitions(${Qt5Widgets_DEFINITIONS})
add_definitions(${Qt5Network_DEFINITIONS})

# Executables fail to build with Qt 5 in the default configuration
# without -fPIE. We add that here.
set(CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ${CMAKE_CXX_FLAGS}")

qt5_wrap_ui(launcher_UI_HEADERS ${launcher_FORMS})

if(WIN32)
	add_executable(vcmilauncher WIN32 ${launcher_SRCS} ${launcher_UI_HEADERS} VCMI_launcher.rc)
	set_target_properties(vcmilauncher PROPERTIES OUTPUT_NAME VCMI_launcher)
else()
	add_executable(vcmilauncher ${launcher_SRCS} ${launcher_UI_HEADERS})
endif()

if(MSVC)
	# Fix _WinMain@16 linking error
	target_link_libraries(vcmilauncher vcmi ${Qt5Core_QTMAIN_LIBRARIES} ${Qt5Widgets_LIBRARIES} ${Qt5Network_LIBRARIES} ${SDL_LIBRARY})
else()
	# The Qt5Widgets_LIBRARIES variable also includes QtGui and QtCore
	target_link_libraries(vcmilauncher vcmi ${Qt5Widgets_LIBRARIES} ${Qt5Network_LIBRARIES} ${SDL_LIBRARY})
endif()

# temporary(?) disabled - generation of PCH takes too much time since cotire is trying to collect all Qt headers
#set_target_properties(vcmilauncher PROPERTIES ${PCH_PROPERTIES})
#cotire(vcmilauncher)

if (NOT APPLE) # Already inside bundle
	install(TARGETS vcmilauncher DESTINATION ${BIN_DIR})
	# copy whole directory but .svn control files
	install(DIRECTORY icons DESTINATION ${DATA_DIR}/launcher PATTERN ".svn" EXCLUDE)
endif()

=== lib/CMakeLists.txt ===
project(libvcmi)
cmake_minimum_required(VERSION 2.6)

include_directories(${CMAKE_HOME_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/include ${CMAKE_CURRENT_SOURCE_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/lib)
include_directories(${Boost_INCLUDE_DIRS} ${SDL_INCLUDE_DIR} ${ZLIB_INCLUDE_DIR})

set(lib_SRCS
		StdInc.cpp
		${CMAKE_BINARY_DIR}/Version.cpp

		filesystem/AdapterLoaders.cpp
		filesystem/CCompressedStream.cpp
		filesystem/CFilesystemLoader.cpp
		filesystem/CArchiveLoader.cpp
		filesystem/CMemoryBuffer.cpp
		filesystem/CMemoryStream.cpp
		filesystem/CBinaryReader.cpp
		filesystem/CFileInputStream.cpp
		filesystem/CZipLoader.cpp
		filesystem/CZipSaver.cpp
		filesystem/FileInfo.cpp
		filesystem/Filesystem.cpp
		filesystem/FileStream.cpp
		filesystem/ResourceID.cpp
		filesystem/MinizipExtensions.cpp

		mapObjects/CArmedInstance.cpp
		mapObjects/CBank.cpp
		mapObjects/CGHeroInstance.cpp
		mapObjects/CGMarket.cpp
		mapObjects/CGPandoraBox.cpp
		mapObjects/CGTownInstance.cpp
		mapObjects/CObjectClassesHandler.cpp
		mapObjects/CObjectHandler.cpp
		mapObjects/CommonConstructors.cpp
		mapObjects/CQuest.cpp
		mapObjects/CRewardableConstructor.cpp
		mapObjects/CRewardableObject.cpp
		mapObjects/JsonRandom.cpp
		mapObjects/MiscObjects.cpp
		mapObjects/ObjectTemplate.cpp

		logging/CBasicLogConfigurator.cpp
		logging/CLogger.cpp

		mapping/CCampaignHandler.cpp
		mapping/CDrawRoadsOperation.cpp
		mapping/CMap.cpp
		mapping/CMapEditManager.cpp
		mapping/CMapInfo.cpp
		mapping/CMapService.cpp
		mapping/MapFormatH3M.cpp
		mapping/MapFormatJson.cpp

		rmg/CMapGenerator.cpp
		rmg/CMapGenOptions.cpp
		rmg/CRmgTemplate.cpp
		rmg/CRmgTemplateZone.cpp
		rmg/CRmgTemplateStorage.cpp
		rmg/CZoneGraphGenerator.cpp
		rmg/CZonePlacer.cpp
 
		serializer/BinaryDeserializer.cpp
		serializer/BinarySerializer.cpp
		serializer/CLoadIntegrityValidator.cpp
		serializer/CMemorySerializer.cpp
		serializer/Connection.cpp
		serializer/CSerializer.cpp
		serializer/CTypeList.cpp

		spells/CSpellHandler.cpp
		spells/ISpellMechanics.cpp
		spells/AdventureSpellMechanics.cpp
		spells/BattleSpellMechanics.cpp
		spells/CreatureSpellMechanics.cpp
		spells/CDefaultSpellMechanics.cpp
		spells/ViewSpellInt.cpp

		BattleAction.cpp
		BattleHex.cpp
		BattleState.cpp
		CArtHandler.cpp
		CBattleCallback.cpp
		CBonusTypeHandler.cpp
		CBuildingHandler.cpp
		CConfigHandler.cpp
		CConsoleHandler.cpp
		CCreatureHandler.cpp
		CCreatureSet.cpp
		CGameInterface.cpp
		CGeneralTextHandler.cpp
		CHeroHandler.cpp
		CModHandler.cpp
		CObstacleInstance.cpp
		CRandomGenerator.cpp

		CThreadHelper.cpp
		CTownHandler.cpp
		GameConstants.cpp
		HeroBonus.cpp
		JsonDetail.cpp
		JsonNode.cpp
		LogicalExpression.cpp
		ResourceSet.cpp
		VCMI_Lib.cpp
		VCMIDirs.cpp
		IHandlerBase.cpp

		IGameCallback.cpp
		CGameInfoCallback.cpp
		CPathfinder.cpp
		CGameState.cpp
		NetPacksLib.cpp

		serializer/JsonSerializer.cpp
		serializer/JsonDeserializer.cpp
		serializer/JsonSerializeFormat.cpp

		registerTypes/RegisterTypes.cpp
		registerTypes/TypesClientPacks1.cpp
		registerTypes/TypesClientPacks2.cpp
		registerTypes/TypesMapObjects1.cpp
		registerTypes/TypesMapObjects2.cpp
		registerTypes/TypesMapObjects3.cpp
		registerTypes/TypesPregamePacks.cpp
		registerTypes/TypesServerPacks.cpp
)

set(lib_HEADERS
		../Global.h

		filesystem/CInputStream.h
		filesystem/ISimpleResourceLoader.h

		mapObjects/MapObjects.h
		mapping/CMapDefines.h

		CSoundBase.h
		AI_Base.h
		CondSh.h
		ConstTransitivePtr.h
		CBonusTypeHandler.h
		CScriptingModule.h
		CStopWatch.h
		FunctionList.h
		GameConstants.h
		StringConstants.h
		IGameEventsReceiver.h
		int3.h
		CGameStateFwd.h
		CPlayerState.h
		Interprocess.h
		NetPacks.h
		NetPacksBase.h
		StartInfo.h
		UnlockGuard.h
		VCMIDirs.h
		vcmi_endian.h
)

add_library(vcmi SHARED ${lib_SRCS} ${lib_HEADERS})
set_target_properties(vcmi PROPERTIES XCODE_ATTRIBUTE_LD_DYLIB_INSTALL_NAME "@rpath/libvcmi.dylib")
set_target_properties(vcmi PROPERTIES COMPILE_DEFINITIONS "VCMI_DLL=1")
target_link_libraries(vcmi ${MINIZIP_LIBRARIES} ${Boost_LIBRARIES} ${SDL_LIBRARY} ${ZLIB_LIBRARIES} ${SYSTEM_LIBS})

if(WIN32)
	set_target_properties(vcmi PROPERTIES OUTPUT_NAME VCMI_lib)
endif()

set_target_properties(vcmi PROPERTIES ${PCH_PROPERTIES})
cotire(vcmi)

if (NOT APPLE) # Already inside vcmiclient bundle
	install(TARGETS vcmi RUNTIME DESTINATION ${LIB_DIR} LIBRARY DESTINATION ${LIB_DIR})
endif()

=== server/CMakeLists.txt ===
project(vcmiserver)
cmake_minimum_required(VERSION 2.6)

include_directories(${CMAKE_HOME_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/include ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_HOME_DIRECTORY}/lib)
include_directories(${Boost_INCLUDE_DIRS} ${ZLIB_INCLUDE_DIR})

set(server_SRCS
		StdInc.cpp
		CGameHandler.cpp
		CVCMIServer.cpp
		CQuery.cpp
		NetPacksServer.cpp
)

add_executable(vcmiserver ${server_SRCS})

target_link_libraries(vcmiserver vcmi ${Boost_LIBRARIES} ${SYSTEM_LIBS})

if(WIN32)
	set_target_properties(vcmiserver PROPERTIES OUTPUT_NAME VCMI_server)
endif()

set_target_properties(vcmiserver PROPERTIES ${PCH_PROPERTIES})
set_target_properties(vcmiserver PROPERTIES XCODE_ATTRIBUTE_LD_RUNPATH_SEARCH_PATHS "@executable_path/../Frameworks @executable_path/")
cotire(vcmiserver)

if (NOT APPLE) # Already inside vcmiclient bundle
	install(TARGETS vcmiserver DESTINATION ${BIN_DIR})
endif()

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

enable_testing()
include_directories(${CMAKE_HOME_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/include ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_HOME_DIRECTORY}/test)
include_directories(${Boost_INCLUDE_DIRS})

set(test_SRCS
		StdInc.cpp
		CVcmiTestConfig.cpp
		CMapEditManagerTest.cpp
    MapComparer.cpp
    CMapFormatTest.cpp
)

add_executable(vcmitest ${test_SRCS})
target_link_libraries(vcmitest vcmi ${Boost_LIBRARIES} ${RT_LIB} ${DL_LIB})
add_test(vcmitest vcmitest)

set_target_properties(vcmitest PROPERTIES ${PCH_PROPERTIES})
cotire(vcmitest)

# Files to copy to the build directory
add_custom_target(vcmitestFiles ALL)
set(vcmitest_FILES
		TerrainViewTest.h3m
		terrainViewMappings.json
)

foreach(file ${vcmitest_FILES})
		add_custom_command(TARGET vcmitestFiles POST_BUILD
				COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_CURRENT_SOURCE_DIR}/${file}" ${CMAKE_CURRENT_BINARY_DIR}
	)
endforeach()

=== AI/BattleAI/CMakeLists.txt ===
project(battleAI)
cmake_minimum_required(VERSION 2.6)

include_directories(${Boost_INCLUDE_DIRS} ${CMAKE_HOME_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/include ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_HOME_DIRECTORY}/lib)

set(battleAI_SRCS
		StdInc.cpp
		BattleAI.cpp
		main.cpp
)

add_library(BattleAI SHARED ${battleAI_SRCS})
target_link_libraries(BattleAI vcmi)

set_target_properties(BattleAI PROPERTIES ${PCH_PROPERTIES})
cotire(BattleAI)

if (NOT APPLE) # Already inside vcmiclient bundle
    install(TARGETS BattleAI RUNTIME DESTINATION ${AI_LIB_DIR} LIBRARY DESTINATION ${AI_LIB_DIR})
endif()

=== AI/EmptyAI/CMakeLists.txt ===
project(emptyAI)
cmake_minimum_required(VERSION 2.6)

include_directories(${Boost_INCLUDE_DIRS} ${CMAKE_HOME_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/include ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_HOME_DIRECTORY}/lib)

set(emptyAI_SRCS
    CEmptyAI.cpp
    exp_funcs.cpp
)

add_library(EmptyAI SHARED ${emptyAI_SRCS})
target_link_libraries(EmptyAI vcmi)

if (NOT APPLE) # Already inside vcmiclient bundle
    install(TARGETS EmptyAI RUNTIME DESTINATION ${AI_LIB_DIR} LIBRARY DESTINATION ${AI_LIB_DIR})
endif()

=== AI/StupidAI/CMakeLists.txt ===
project(stupidAI)
cmake_minimum_required(VERSION 2.6)

include_directories(${Boost_INCLUDE_DIRS} ${CMAKE_HOME_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/include ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_HOME_DIRECTORY}/lib)

set(stupidAI_SRCS
		StdInc.cpp
		StupidAI.cpp
		main.cpp
)

add_library(StupidAI SHARED ${stupidAI_SRCS})
target_link_libraries(StupidAI vcmi)

set_target_properties(StupidAI PROPERTIES ${PCH_PROPERTIES})
cotire(StupidAI)

if (NOT APPLE) # Already inside vcmiclient bundle
    install(TARGETS StupidAI RUNTIME DESTINATION ${AI_LIB_DIR} LIBRARY DESTINATION ${AI_LIB_DIR})
endif()

=== AI/VCAI/CMakeLists.txt ===
project(VCAI)
cmake_minimum_required(VERSION 2.6)

if (FL_FOUND)
    include_directories(${FL_INCLUDE_DIRS})
else()
    include_directories(${CMAKE_HOME_DIRECTORY}/AI/FuzzyLite/fuzzylite)
endif()
include_directories(${Boost_INCLUDE_DIRS} ${CMAKE_HOME_DIRECTORY} ${CMAKE_HOME_DIRECTORY}/include ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_HOME_DIRECTORY}/lib)

set(VCAI_SRCS
    StdInc.cpp
    VCAI.cpp
    Goals.cpp
    AIUtility.cpp
    main.cpp
    Fuzzy.cpp
)

add_library(VCAI SHARED ${VCAI_SRCS})
if (FL_FOUND)
    target_link_libraries(VCAI ${FL_LIBRARIES} vcmi)
else()
    target_link_libraries(VCAI fl-static vcmi)
endif()

set_target_properties(VCAI PROPERTIES ${PCH_PROPERTIES})
cotire(VCAI)

if (NOT APPLE) # Already inside vcmiclient bundle
    install(TARGETS VCAI RUNTIME DESTINATION ${AI_LIB_DIR} LIBRARY DESTINATION ${AI_LIB_DIR})
endif()

=== debian/changelog ===
vcmi (0.99+dfsg-5ubuntu1) cosmic; urgency=medium

  * Force old boost 1.65 to fix a FTBFS with new boost

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Aug 2018 15:25:09 +0200

vcmi (0.99+dfsg-5) unstable; urgency=medium

  * debian/control: fix my name in Uploaders field
  * Add patch to fix campaigns (closes: #905652)

 -- Johannes 'josch' Schauer <josch@debian.org>  Wed, 08 Aug 2018 17:15:23 +0200

vcmi (0.99+dfsg-4) unstable; urgency=medium

  * Build with ggc-min-expand=5 on mips and mipsel
  * Enable parallel build. All buildds should have enough RAM these days.

 -- Johannes Schauer <josch@debian.org>  Wed, 09 May 2018 22:34:11 +0200

vcmi (0.99+dfsg-3) unstable; urgency=medium

  * Add patch to also search /usr/share/games for assets (closes: #783030)
  * Explain what VCMI stands for in the package description
  * debian/control: Suggest usage of game-data-packager
  * debian/control: recommend ffmpeg instead of libav-tools (closes: #895918)
  * debian/control: change vcs to salsa
  * debian/copyright: Use HTTPS Format URI
  * debian/copyright: explain why the package belongs to contrib
  * debian/control: bump Standards-Version to 4.1.4 (no changes)
  * debian/rules: remove get-orig-source target and add compression=xz to
    debian/watch options
  * debian/rules: explicitly build with --no-parallel
  * Bump dh compat level to 11

 -- Johannes Schauer <josch@debian.org>  Wed, 18 Apr 2018 21:07:52 +0200

vcmi (0.99+dfsg-2) unstable; urgency=medium

  * Add patch from upstream which makes sure that removing a mod cannot
    accidentally recursively delete $HOME (closes: #863301)

 -- Johannes Schauer <josch@debian.org>  Thu, 25 May 2017 08:12:26 +0200

vcmi (0.99+dfsg-1) unstable; urgency=medium

  * new upstream release
  * remove patches boost1.60.diff, build_with_boost_1.58 and ffmpeg_2.9.patch
    as they all have been included by upstream
  * add Build-Depends on libboost-test-dev
  * add patch minizip_maxu32
  * Make Vcs fields use a secure uri
  * Bump Standards-Version to 3.9.8 (no changes required)
  * add patch fix-spelling

 -- Johannes Schauer <josch@debian.org>  Tue, 08 Nov 2016 10:35:01 -0200

vcmi (0.98+dfsg-3) unstable; urgency=medium

  * Team upload.

  [ Gianfranco Costamagna ]
  * Acknowledge previous NMU, thanks!

  [ Stephen Kitt ]
  * Migrate to dbgsym debug packages.

  [ Matthias Klose ]
  * Fix build failure with boost1.60.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Aug 2016 18:33:10 +0200

vcmi (0.98+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Andreas Cadhalpun ]
  * Fix build with ffmpeg 3.0. (Closes: #803866)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 24 Apr 2016 19:35:24 +0200

=== debian/control ===
Source: vcmi
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen Kitt <skitt@debian.org>, Johannes 'josch' Schauer <josch@debian.org>
Build-Depends:
 debhelper (>= 11),
 cmake,
 libminizip-dev,
 libfuzzylite-dev,
 libsdl2-dev,
 libsdl2-image-dev,
 libsdl2-mixer-dev,
 libsdl2-ttf-dev,
 zlib1g-dev,
 libavformat-dev,
 libswscale-dev,
 libboost1.65-dev,
 libboost-program-options1.65-dev,
 libboost-filesystem1.65-dev,
 libboost-system1.65-dev,
 libboost-locale1.65-dev,
 libboost-thread1.65-dev,
 libboost-test1.65-dev,
 qtbase5-dev,
 help2man,
 tex4ht,
 texlive-latex-base,
 texlive-latex-extra
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/games-team/vcmi
Vcs-Git: https://salsa.debian.org/games-team/vcmi.git
Homepage: http://vcmi.eu

Package: vcmi
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: unshield, innoextract, unzip, ffmpeg
Suggests: homm3-demo-data | homm3-data
Description: Rewrite of the Heroes of Might and Magic 3 game engine
 The purpose of VCMI project is to create a free implementation of the "Heroes
 of Might and Magic 3: In the Wake of Gods" engine to overcome limitations
 of the original engine for better modding support, higher resolutions,
 bigger map sizes and extended engine limits.
 .
 VCMI is a turn-based strategy game where the player controls a number of
 heroes commanding an army of creatures. The player explores the game map
 with their heroes, conquers enemy towns and improves their own.
 .
 VCMI stands for Vinyar Callor Meletya Ingole which means "New Heroes of Might
 and Magic" in Quenya.
 .
 This game requires the graphics, sound and videos of the "Heroes of Might and
 Magic 3: In the Wake of Gods" game. After installing this package, run either
 one of the following commands depending on whether you have access to the
 Good Old Games installer (1), the original CDs (2) or just the installed
 game directory (3):
 .
  (1): vcmibuilder --gog /path/to/gog.com/installer
  (2): vcmibuilder --cd1 /path/to/iso/or/cd --cd2 /path/to/second/cd
  (3): vcmibuilder --data /path/to/h3/data
 .
 Alternatively, use `game-data-packager heroes3`.
 .
 This package contains the game engine.

=== debian/rules ===
#! /usr/bin/make -f

# for DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# On mips and mipsel, each process is limited to 2 GB of memory. Because
# gcc manages its memory badly, it will randomly run out of memory. As a
# workaround we force the garbage collector to drop memory more aggressively.
#
# See Debian bug #849657 and
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=79030
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
  export DEB_CXXFLAGS_MAINT_APPEND+=--param ggc-min-expand=5
endif

BUILDDIR=$(CURDIR)/build

%:
	dh $@ --builddirectory=$(BUILDDIR)

# override disabled by default rpath - we need to find libvcmi.so with it:
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=OFF -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBIN_DIR=games

override_dh_strip:
	dh_strip --ddeb-migration='vcmi-dbg (<< 0.98+dfsg-3~)'

# we have to set HOME to a temporary directory when running vcmiserver because
#  - when running vcmiserver it wants to create $HOME/.config/vcmi,
#    $HOME/.cache/vcmi and $HOME/.local/share/vcmi/Saves
#  - sbuild uses the non-existing path /sbuild-nonexistent and the vcmiserver
#    invocation would fail because it cannot create it
#  - we don't want to touch the home directory of the user running dpkg-buildpackage
%.1: debian/%.1.in
	HOME=$(BUILDDIR) help2man --version-string=$(DEB_VERSION_UPSTREAM) --include=$< --output=$@ ./`basename $@ .1`

override_dh_installman: vcmiserver.1 vcmibuilder.1 vcmiclient.1
	dh_installman

override_dh_auto_install:
	dh_auto_install --destdir=debian/vcmi

override_dh_auto_build:
	dh_auto_build
	ln -s $(BUILDDIR)/server/vcmiserver ./vcmiserver
	ln -s $(BUILDDIR)/client/vcmiclient ./vcmiclient
	htlatex vcmimanual.tex

override_dh_auto_clean:
	dh_auto_clean
	rm -f ./vcmiclient ./vcmiserver
	rm -f vcmimanual.4ct vcmimanual.4tc vcmimanual.aux vcmimanual.css \
	vcmimanual.dvi vcmimanual.html vcmimanual.idv vcmimanual.lg \
	vcmimanual.log vcmimanual.tmp vcmimanual.xref
